<?php
bxc_debug('w');
class ControllerExtensionPaymentBoxcoin extends Controller {

	public function index() {
		$this->load->language('extension/payment/boxcoin');
		$data['language'] = $this->config->get('config_language');
		return $this->load->view('extension/payment/boxcoin', $data);
	}

	public function confirm() {
		$json = [];
		$this->load->language('extension/payment/boxcoin');
        $session = $this->session->data;
        $order_id = isset($session['order_id']) ? $session['order_id'] : false;
        if (!$order_id) {
			$json['error'] = $this->language->get('error_order');
		}
		if (!$json) {
            $this->load->model('checkout/order');
            $order_data = [];
            $customer = isset($session['customer']) ? $session['customer'] : $session['guest'];
            $order_data['customer_group_id'] = isset($customer['customer_group_id']) ?$customer['customer_group_id'] : '';
            $order_data['marketing_id'] = 0;
            $order_data['tracking'] = '';
            $order_info = $this->model_checkout_order->getOrder($order_id);
            $order_data = array_merge($order_data, $order_info);
            if ($this->config->get('config_affiliate_status') && isset($session['tracking'])) {
                $subtotal = $this->cart->getSubTotal();
                $this->load->model('account/affiliate');
                $affiliate_info = $this->model_account_affiliate->getAffiliateByTracking($session['tracking']);
                if ($affiliate_info) {
                    $order_data['affiliate_id'] = $affiliate_info['customer_id'];
                    $order_data['commission'] = ($subtotal / 100) * $affiliate_info['commission'];
                    $order_data['tracking'] = $session['tracking'];
                }
            }
            $this->load->model('checkout/order');
            $this->model_checkout_order->addOrder($order_data);
            $this->model_checkout_order->addOrderHistory($order_id, '2');
            $this->cart->clear();
            unset($session['order_id']);
            unset($session['payment_address']);
            unset($session['payment_method']);
            unset($session['payment_methods']);
            unset($session['shipping_address']);
            unset($session['shipping_method']);
            unset($session['shipping_methods']);
            unset($session['comment']);
            unset($session['coupon']);
            unset($session['reward']);
            unset($session['voucher']);
            unset($session['vouchers']);
            $cloud = $this->config->get('payment_boxcoin_cloud_key');
            $json['redirect'] = str_replace('//pay.php', '/pay.php', str_replace('admin.php', '', $this->config->get('payment_boxcoin_url')) . '/pay.php?checkout_id=custom-oc&price=' . $order_info['total'] . '&currency=' . $order_info['currency_code'] . '&external-reference=' . bxc_oc_encryption($order_id) . '&lang=' . substr($order_info['language_code'], 0, 2) . '&redirect=' . urlencode($this->url->link('checkout/success', 'language=' . $order_info['language_code'], true)) . ($cloud ? '&cloud=' . trim($cloud) : ''));
			$this->response->addHeader('Content-Type: application/json');
            $this->response->setOutput(json_encode($json));
        }
	}

    public function callback() {
		$output = false;
        $response = json_decode(file_get_contents('php://input'), true);
		if (isset($response['transaction'])) {
			$transaction = $response['transaction'];
			$order_id = bxc_oc_encryption($transaction['external_reference'], false);
			if ($order_id && is_numeric($order_id)) {
				$this->load->model('checkout/order');
                $order = $this->model_checkout_order->getOrder($order_id);
                if (trim($response['key']) !== trim($this->config->get('payment_boxcoin_webhook_key'))) $output = ['error' => 'Invalid webhook key.'];
                else if (floatval($order['total']) !== floatval($transaction['amount_fiat'])) $output = ['error' => 'Invalid amount.'];
                else {
                    $this->model_checkout_order->addOrderHistory($order_id, 5, 'Boxcoin transaction ID: ' . $transaction['id']);
                    $output = ['success' => true];
                }
            } else {
                $output = ['error' => 'Invalid external_reference value: ' . $transaction['external_reference']];
            }
        }
		if (isset($output['error'])) bxc_oc_debug($output['error']);
        $this->response->addHeader('Content-Type: application/json');
        $this->response->setOutput(json_encode($output));
    }
}

function bxc_oc_encryption($string, $encrypt = true) {
    $output = false;
    $encrypt_method = 'AES-256-CBC';
	$password = DB_PASSWORD ? DB_PASSWORD : '12345678';
    $secret_key = $password . DB_USERNAME;
    $key = hash('sha256', $secret_key);
    $iv = substr(hash('sha256', $password), 0, 16);
    if ($encrypt) {
        $output = openssl_encrypt($string, $encrypt_method, $key, 0, $iv);
        $output = base64_encode($output);
        if (substr($output, -1) == '=') $output = substr($output, 0, -1);
    } else {
        $output = openssl_decrypt(base64_decode($string), $encrypt_method, $key, 0, $iv);
    }
    return $output;
}

function bxc_oc_debug($value) {
    $path = __DIR__ . '/debug.txt';
    $value = is_string($value) ? $value : json_encode($value);
    if (file_exists($path)) {
        $value = file_get_contents($path) . PHP_EOL . $value;
    }
    $file = fopen($path, 'w');
    fwrite($file, $value);
    fclose($file);
}